#ifndef __GCCIM_HH__
#define __GCCIM_HH__

#include "Cover.h"
#include "Stack_Of_Cover.h"
// #include "infosutiles.h"

extern int CurFreq; // frequency
extern Cover coverD; // initial Cover which contains all transactions
Stack_Of_Cover Stack_Instance; // Instance of the classe representing the stack of pairs <cover, sigma_1>
vector <int> sigma_0_Old; // Save sigma_0 to compute new items instaciated to 0 
bool print_states = false; // Allow print state of (sigma_0/sigma_1/sigma_01)

namespace GCCIM {

void Cover_Incremental(vector <int> sigma_1, vector <int> sigma_0, vector <int> sigma_01, int mins){
			
	// Descendre jusqu'a arriver à un point (sigma, cover) où le sommet de la pile Psigma_1 est inlcut dans sigma_1 courant
	while(!(Stack_Instance.Inlcus(sigma_1))){
		Stack_Instance.Depiler_Cover_Sigma_1_();
	}	
	bool egal = Stack_Instance.Egaux(sigma_1);
	if(!egal){
		// instanciation à 1
		Cover *PPD_ = new Cover(); // pointeur sur la classe cover	
		vector <int> new_Items;
		new_Items = Stack_Instance.Diffrence_Sigma_1(sigma_1); // Faire la diff entre sigma_1 et Psigma_1 (on sait pas quel/combien d'item(s) ont été ajoutés à sigma_1
		
		Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Compute_New_Cover(new_Items, PPD_); // Calcul couverture : intersection des cover de tous les news items	
		Stack_Instance.Emplier_Cover_Sigma_1_(PPD_,sigma_1); // Ajouter (Cover,sigma_1)
		
		// Les calculs des ensembles : NoFrequentItems, Closure et Inclusion (ou Maximal et Inclusion_maximal selon le choix du user) pour filtrer en utilisant le dernier cover
		//if(choix == "c")		
			Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Frequent_Closed_Itemsets(mins, sigma_1, sigma_0, sigma_01); // motifs clos
		//else if(choix == "m")
			//Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Frequent_Maximal_Itemsets(mins, sigma_1, sigma_0, sigma_01);	// motifs maximaux	
	}
	else{ 
		// instanciation à 0 : ici on utilise l'ancien cover pour chercher les inclusions, on ne calcul pas un nouveau cover
		vector<int> New_Items_0; // quels nouveau items ont été mis à 0 (comparer avec l'ancien sigma_0 stocké)
		set_symmetric_difference(sigma_0_Old.begin(), sigma_0_Old.end(), sigma_0.begin(), sigma_0.end(), back_inserter(New_Items_0));
		
		if(print_states){
			cout << "---------------------" << endl;
			cout << "sigma_1" << endl;
			for(int i = 0; i < sigma_1.size(); i++)
				cout << sigma_1[i] << " ";
			cout << endl;
			cout << "sigma_01" << endl;
			for(int i = 0; i < sigma_01.size(); i++)
				cout << sigma_01[i] << " ";
			cout << endl;
			cout << "sigma_0" << endl;
			for(int i = 0; i < sigma_0.size(); i++)
				cout << sigma_0[i] << " ";
			cout << endl;
			
			//cout << "New_Items_0 before" << endl;
			//for(int i = 0; i < New_Items_0.size(); i++)
			//	cout << New_Items_0[i] << " ";
			//cout << endl;
		}
		sigma_0_Old.clear();
		sigma_0_Old = sigma_0; // Update sigma_0_Old for next difference
		// Suprrimer les items qui peuvent être dans sigma_1 ou sigma_01 (on sait pas ce qui c'est passé das le filtarge quand p_k = 1)
		// RQ : New_Items_0 est un sous ensemble de sigma_0 //	
		for ( unsigned int j =0; j < New_Items_0.size(); j++){
			if( (find(sigma_0.begin(), sigma_0.end(), New_Items_0[j]) == sigma_0.end())){ 
				New_Items_0.erase(std::remove(New_Items_0.begin(), New_Items_0.end(), New_Items_0[j]), New_Items_0.end());
				j--;
			}		
		}
		if(print_states){
			//cout << "New_Items_0 après" << endl;
			//for(int i = 0; i < New_Items_0.size(); i++)
			//	cout << New_Items_0[i] << " ";
			//cout << endl;
		//	cout << "-----------------" << endl;			
		}
		// chercher les inclusions
		Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Inclusion_test_0(mins, sigma_0, sigma_01); // chercher les inclusion sur New_Items_0	
		if(print_states){
			cout << "Inclusion : " << endl;
			for(int i = 0; i < Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Inclusion.size(); i++)
				cout << Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Inclusion[i] << " ";
			cout << endl;
			cout << "-----------------" << endl;
		}	
	}
}

using namespace std;
using namespace ::Gecode;
using namespace ::Gecode::Int;

template <class View>
class GCCIMConst : public NaryPropagator<View,PC_INT_DOM> {
	
	protected:
		using NaryPropagator<View,PC_INT_DOM>::x;
		int minsup;		
		GCCIMConst(Space& home, ViewArray<View>& x, int freq0); // Constructor for posting		
		GCCIMConst(Space& home, bool share, GCCIMConst<View>& p); // Constructor for cloning \a p
  
	public:		
		virtual Actor* copy(Space& home, bool share); // Copy propagator during cloning
		// Perform propagation
		virtual ExecStatus propagate(Space& home, const ModEventDelta& med);
		virtual size_t dispose(Space& home);		
		static ExecStatus post(Space& home, ViewArray<View>& x, int minsup0); // Post propagator for view array \a x
};
  
/// Algorithme de filtrage :
template <class View> size_t GCCIMConst<View>::dispose(Space& home){    
    for(unsigned int i=0; i < x.size(); i++)
		x[i].cancel(home, *this, PC_INT_DOM);
    (void)Propagator::dispose(home);
    return sizeof(*this);
};
template <class View>
	forceinline
	GCCIMConst<View>::GCCIMConst(Space& home, ViewArray<View>& x, int freq0): NaryPropagator<View,PC_INT_DOM>(home,x) {
		x.subscribe(home,*this,PC_INT_DOM);
		minsup = freq0;
	}	
// the copy-constructor to copy the propagator
template <class View>
	forceinline
	GCCIMConst<View>::GCCIMConst(Space& home, bool share, GCCIMConst<View>& p): NaryPropagator<View,PC_INT_DOM>(home,share,p), minsup(p.minsup) {
		x.update(home,share,p.x);
	}	
template <class View>
	Actor*
	GCCIMConst<View>::copy(Space& home, bool share) {
		return new (home) GCCIMConst<View>(home,share,*this);
	}
template <class View>
	ExecStatus
	GCCIMConst<View>::post(Space& home, ViewArray<View>& x, int minsup0){
		(void) new (home) GCCIMConst<View>(home,x,minsup0);
		return ES_OK;
	}

/// Filtrage "Propagate()" : Propagateur appelé à chaque noeud
template <class View>
	ExecStatus
	GCCIMConst<View>::propagate(Space& home, const ModEventDelta&) { 
		
		//printf("Top %d ; %d prunes; mem: %lu\n", Covers_.size(), mem_usage());		
		Cover *PPD;
		vector <int> sigma_1, sigma_0, sigma_01;
		int sum = 0;
				
		/// Get sigma_0, sigma_1, sigma_01
		for(unsigned int i = 0; i < x.size(); i++){
			
			if(x[i].assigned()){	
				sum = sum + x[i].val();	// Sum of instanciated variables					
				// value of the current instanciation 0 or 1
				if(x[i].val() == 0)
					sigma_0.push_back(i+1);
				else if(x[i].val() == 1)
					sigma_1.push_back(i+1);					
			}
			else{ // not instanciated variable
				sigma_01.push_back(i+1);
			}			
		}
	
		if(sum >= 0){
			
			if(sum == 0){ // All variables instanciated to "1"					
				if(Stack_Instance.Covers_.empty()) // no cover saved
					Stack_Instance.Emplier_Cover_Sigma_1_(&coverD,sigma_1);// Add (initial cover, empty sigma)			
				
				// instanciation to 0
				PPD = Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]; // Last saved cover
				if((!sigma_0.empty())&&(!sigma_01.empty()))	{
					
					vector <int> Diff_0; // new items instanciated to 0
					set_symmetric_difference(sigma_0_Old.begin(), sigma_0_Old.end(), sigma_0.begin(), sigma_0.end(), back_inserter(Diff_0));
					sigma_0_Old.clear();
					sigma_0_Old = sigma_0; // Update sigma_0_0 to compute next differences					
					// Delete items that appear in sigma_01
					for ( unsigned int j =0; j < Diff_0.size(); j++){
						if (find(sigma_0.begin(), sigma_0.end(), Diff_0[j]) == sigma_0.end()){ 
							Diff_0.erase(std::remove(Diff_0.begin(), Diff_0.end(), Diff_0[j]), Diff_0.end());
							j--;
						}		
					}									
					PPD->Inclusion_test_00(sigma_0, sigma_01); // Trouver les inclusions sur les nouveaux items mis à 0
					if(print_states){
						cout << "---------------------" << endl;
						cout << "sigma_1" << endl;
						for(int i = 0; i < sigma_1.size(); i++)
							cout << sigma_1[i] << " ";
						cout << endl;
						cout << "sigma_01" << endl;
						for(int i = 0; i < sigma_01.size(); i++)
							cout << sigma_01[i] << " ";
						cout << endl;
						cout << "sigma_0" << endl;
						for(int i = 0; i < sigma_0.size(); i++)
							cout << sigma_0[i] << " ";
						cout << endl;
						cout << "Inclusion" << endl;
						for(int i = 0; i < PPD->Inclusion.size(); i++)
							cout << PPD->Inclusion[i] << " ";
						cout << endl;
					}
					// Inclusion filtering
					if(sigma_0.size() + sigma_1.size() != x.size()){
						for(int g = 0; g < PPD->Inclusion.size(); g++){
							GECODE_ME_CHECK(x[PPD->Inclusion[g]-1].eq(home,0));
						}
					}
				}
				return ES_NOFIX;
			}
			else{
				// instanciation to 1
				Cover_Incremental(sigma_1, sigma_0, sigma_01, minsup); // Calculer le cover du sigma_1 actuel de manière incrementale
				PPD = Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1];
				if(print_states){
						cout << "---------------------" << endl;
						cout << "sigma_1" << endl;
						for(int i = 0; i < sigma_1.size(); i++)
							cout << sigma_1[i] << " ";
						cout << endl;
						cout << "sigma_01" << endl;
						for(int i = 0; i < sigma_01.size(); i++)
							cout << sigma_01[i] << " ";
						cout << endl;
						cout << "sigma_0" << endl;
						for(int i = 0; i < sigma_0.size(); i++)
							cout << sigma_0[i] << " ";
						cout << endl;
						cout << "Liste cover" << endl;
						for(int i = 0; i < PPD->Liste_Cover.size(); i++)
							cout << PPD->Liste_Cover[i] << " ";
						cout << endl;
						cout << "Closure" << endl;
						for(int i = 0; i < PPD->Closure.size(); i++)
							cout << PPD->Closure[i] << " ";
						cout << endl;
						cout << "Not frequent items" << endl;
						for(int i = 0; i < PPD->NotFreqItems.size(); i++)
							cout << PPD->NotFreqItems[i] << " ";
						cout << endl;
						cout << "Inclusion" << endl;
						for(int i = 0; i < PPD->Inclusion.size(); i++)
							cout << PPD->Inclusion[i] << " ";
						cout << endl;
				}
				// Si |Base projetée| < minsup => echec		
				CurFreq = PPD->Liste_Cover.size(); // Récuperer la fréquence d'un prefix : égale à la taille de son cover	
				if(CurFreq < minsup){
					return ES_FAILED;
				}
			
				// Calcul cloture : items dont le cover est max : son cover contient que des "1"
				if (!PPD->Closure.empty()){
					for(unsigned int g = 0; g < PPD->Closure.size(); g++){
						GECODE_ME_CHECK(x[PPD->Closure[g]-1].eq(home, 1));
					}
				}	
			
				// Calcul maximaux : items pour les quels il exite une transaction avec des "1" partout
				if (!PPD->Maximal.empty()){
					for(unsigned int g = 0; g < PPD->Maximal.size(); g++){
						GECODE_ME_CHECK(x[PPD->Maximal[g]-1].eq(home, 1));
					}
				}			
			
				// Filtrer les items non fréquents + inclus
				if(sigma_0.size() + sigma_1.size() != x.size()){
				
					// Get Non Frequents items :
					for(int g = 0; g < PPD->NotFreqItems.size(); g++){					
						GECODE_ME_CHECK(x[PPD->NotFreqItems[g]-1].eq(home,0));
					}
					// Inclusions :
					for(int g = 0; g < PPD->Inclusion.size(); g++){					
						GECODE_ME_CHECK(x[PPD->Inclusion[g]-1].eq(home,0));
					}	
					// Inclusions des Maximaux:
					for(int g = 0; g < PPD->Maximal_Inclusion.size(); g++){					
						GECODE_ME_CHECK(x[PPD->Maximal_Inclusion[g]-1].eq(home,0));
					}
					return ES_NOFIX;					
				}			
				else{
					return home.ES_SUBSUMED(*this); // toutes les variables sont instanciées
				}
			}
			delete PPD; // détruire le pointeur...
		}
	}
	
	void Closed_Itemset_Constraint(Space& home, const IntVarArgs& Pattern, int minsup) {

		if (home.failed())
			return;

		IntVarArgs BVA;
		BVA << Pattern;
		ViewArray<IntView> xv(home,BVA);
		
		GECODE_ES_FAIL(GCCIM::GCCIMConst<IntView>::post(home,xv,minsup));
		
	}
}
#endif // __GCCIM_HH__
